﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Charts;

namespace xamDataChartDragPoints
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var Trades = new ObservableCollection<LiveViewDataPoint>();

            Trades.Add(new LiveViewDataPoint() { Date = 25, Price = 25.68 });
            Trades.Add(new LiveViewDataPoint() { Date = 25, Price = 5.68 });
            Trades.Add(new LiveViewDataPoint() { Date = 58, Price = 45.56 });
            Trades.Add(new LiveViewDataPoint() { Date = 165, Price = 125.68 });

            this.xamChart1.DataContext = Trades;

            xamChart1.PreviewMouseLeftButtonDown += new MouseButtonEventHandler(xamChart1_PreviewMouseLeftButtonDown);
        }

        void xamChart1_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            var series = this.xamChart1.Series.FirstOrDefault();
            if (series == null) return; 

            var position = e.GetPosition(series);

            if (series.Chart.Axes.OfType<NumericXAxis>().Any())
            {
                var xAxis = series.Chart.Axes.OfType<NumericXAxis>().First();
                var yAxis = series.Chart.Axes.OfType<NumericYAxis>().First();

                var viewport = new Rect(0, 0, xAxis.ActualWidth, yAxis.ActualHeight);
                var window = series.Chart.WindowRect;

                var unscaledX = xAxis.GetUnscaledValue(position.X, window, viewport);
                var unscaledY = yAxis.GetUnscaledValue(position.Y, window, viewport);

                

                var tmp = xamChart1.DataContext as ObservableCollection<LiveViewDataPoint>;
                tmp.Add(new LiveViewDataPoint() { Date = (int)unscaledX, Price = unscaledY });
            }
            
        }
    }

    public class LiveViewDataPoint
    {
        public int Date { get; set; }
        public double Price { get; set; }
    }
}
